﻿@page "/matches/Futsal/{MatchCoreId:int}"

@using Business.Repository.IRepository
@using Data
@using Models.MatchData
@using Models.RefereeData
@using Models.StadiumData 
@using Dialog

@inject IJSRuntime JsRuntime

@inject IMatchFutsalRepository MatchFutsalRepository
@inject IMatchCoreRepository MatchCoreRepository
@inject IMatchCommentaryRepository MatchCommentaryRepository
@inject IStadiumRepository StadiumRepository 
@inject IRefereeMatchRepository RefereeMatchRepository
@inject IRefereeRepository RefereeRepository
@inject IModalDialogService ModalDialog

<div class="row mt-2 mb-5">
    <h3 class="card-title text-info mb-3 ml-3">Match Time</h3>
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                @*<ValidationSummary />*@
                <div class="row">
                    <div class="col-4">
                        Start Time:
                        <input type="number" class="inputNoArrows inputStyle" @bind="minutes" />
                    </div>
                    <div class="col-6">
                        @String.Format("Game Time: {0:00}:{1:00}", minutes, seconds)
                        <button @onclick=Start class="btn btn-success">Start</button>
                        <button @onclick=Stop class="btn btn-danger">Stop</button>
                        <button @onclick="Reset" class="btn btn-primary">Reset</button>
                        
                    </div>
                    <div class="col-2">
                        <button @onclick="Finished" class="btn btn-info float-right">Finish Match</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

@if (MatchFutsalModel.Id > 0)
{ 
    <div class="row mt-2 mb-5">
        <h3 class="card-title text-info mb-3 ml-3">Match Score</h3>
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    @*<ValidationSummary />*@
                    <div class="row align-items-center text-center">
                        <div class="col-5">
                            <p class="h5 text-secondary text-center"><strong>@MatchCoreModel.TeamHome.Name</strong></p>
                        </div>

                        <div class="col-2">
                            <svg xmlns="http://www.w3.org/2000/svg" width="21" height="20" fill="currentColor" class="bi bi-arrow-up-circle-fill greyHover mr-2" viewBox="0 0 16 16" @onclick="PlusHomeTeam">
                                <path d="M16 8A8 8 0 1 0 0 8a8 8 0 0 0 16 0zm-7.5 3.5a.5.5 0 0 1-1 0V5.707L5.354 7.854a.5.5 0 1 1-.708-.708l3-3a.5.5 0 0 1 .708 0l3 3a.5.5 0 0 1-.708.708L8.5 5.707V11.5z" />
                            </svg>
                            <svg xmlns="http://www.w3.org/2000/svg" width="21" height="20" fill="currentColor" class="bi bi-arrow-up-circle-fill greyHover ml-2" viewBox="0 0 16 16" @onclick="PlusAwayTeam">
                                <path d="M16 8A8 8 0 1 0 0 8a8 8 0 0 0 16 0zm-7.5 3.5a.5.5 0 0 1-1 0V5.707L5.354 7.854a.5.5 0 1 1-.708-.708l3-3a.5.5 0 0 1 .708 0l3 3a.5.5 0 0 1-.708.708L8.5 5.707V11.5z" />
                            </svg>

                            <div>
                                <input type="number" class="inputNoArrows inputStyle" @bind="MatchCoreModel.TeamHomeScore" /> : <input type="number" class="inputNoArrows inputStyle" @bind="MatchCoreModel.TeamAwayScore" />
                            </div>

                            <svg xmlns="http://www.w3.org/2000/svg" width="21" height="20" fill="currentColor" class="bi bi-arrow-down-circle-fill greyHover mr-2" viewBox="0 0 16 16" @onclick="MinusHomeTeam">
                                <path d="M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0zM8.5 4.5a.5.5 0 0 0-1 0v5.793L5.354 8.146a.5.5 0 1 0-.708.708l3 3a.5.5 0 0 0 .708 0l3-3a.5.5 0 0 0-.708-.708L8.5 10.293V4.5z" />
                            </svg>
                            <svg xmlns="http://www.w3.org/2000/svg" width="21" height="20" fill="currentColor" class="bi bi-arrow-down-circle-fill greyHover ml-2" viewBox="0 0 16 16" @onclick="MinusAwayTeam">
                                <path d="M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0zM8.5 4.5a.5.5 0 0 0-1 0v5.793L5.354 8.146a.5.5 0 1 0-.708.708l3 3a.5.5 0 0 0 .708 0l3-3a.5.5 0 0 0-.708-.708L8.5 10.293V4.5z" />
                            </svg>
                        </div>
                        <div class="col-5">
                            <p class="h5 text-secondary text-center"><strong>@MatchCoreModel.TeamAway.Name</strong></p>
                        </div>
                        <div class="col-12">
                            <button class="btn btn-primary mt-4" @onclick="HandleChangeScore">Save score</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
}

<div class="row mt-4 mb-5 border-0">
    <div class="col-8">
        <h4 class="card-title text-info">Comments</h4>
    </div>
    <div class="col-3 offset-1 mb-2">
        <button @onclick="() => HandleAddComment(MatchFutsalModel.MatchId, minutes)" class="btn btn-primary form-control">Add new comment</button>
    </div>
    <div class="col-md-12 border-0">
        <div class="card border-0">
            <div class="card-body border-0">
                @*<ValidationSummary />*@
                <div class="row align-items-center text-center border-0">
                    <table class="table table-hover border-0">
                        <thead>
                            <tr>
                                <th width="10%">Minute</th>
                                <th>Comment</th>
                                <th width="10%">
                                    Actions
                                </th>
                            </tr>
                        </thead>
                        <tbody>
                            @if (MatchCommentaryList.Any())
                            {
                                @foreach (var comment in MatchCommentaryList.OrderBy(x => x.Minute))
                                {
                                    <tr>
                                        <td>@comment.Minute'</td>
                                        <td>@comment.Comment</td>
                                        <td>
                                            <button @onclick="() => HandleCommentEdit(comment.Id, MatchFutsalModel.Id, minutes)" class="btn btn-primary">Edit</button>
                                            <button class="btn btn-danger" @onclick="() => HandleDeleteComment(comment.Id)">Delete</button>
                                        </td>
                                    </tr>
                                }
                            }
                            else
                            {
                                <tr>
                                    <td colspan="12">No records found</td>
                                </tr>
                            }
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

<div class="row mt-2 mb-5">
    <h3 class="card-title text-info mb-3 ml-3">Information</h3>
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                @*<ValidationSummary />*@
                <div class="row align-items-center text-center">
                    <div class="col-6">
                        <label>Referee</label>
                        <select class="form-select centerSelect" style="width:50%; text-align:center;" @bind="SelectedRefereeId">
                            @if (RefereeMatchModel != null && RefereeMatchModel.Referee != null)
                            {
                                <option value="-1">--select--</option>
                                <option value="@RefereeMatchModel.Id" selected>@RefereeMatchModel.Referee.Name @RefereeMatchModel.Referee.Surname </option>
                                @foreach (var referee in Referees.Where(x => x.Id != RefereeMatchModel.Referee.Id))
                                {
                                    <option class="p-3" value="@referee.Id">@referee.Name @referee.Surname</option>
                                }

                            }
                            else
                            {
                                <option value="-1">--select--</option>
                                @foreach (var referee in Referees)
                                {
                                    <option class="p-3" value="@referee.Id">@referee.Name @referee.Surname</option>
                                }
                            }

                        </select>
                        <button class="btn btn-primary mt-2" @onclick="HandleChangeReferee">Save</button>
                    </div>
                    <div class="col-6">
                        <label>Location</label>
                        <select class="form-select centerSelect" style="width:50%; text-align:center;" @bind="SelectedLocationId">
                            @if (MatchCoreModel.Stadium != null)
                            {
                                <option value="-1">---select---</option>
                                <option value="@MatchCoreModel.Stadium.Id" selected>@MatchCoreModel.Stadium.Name</option>
                                @foreach (var location in Locations.Where(x => x.Id != MatchCoreModel.Stadium.Id))
                                {
                                    <option class="p-3" value="@location.Id">@location.Name</option>
                                }
                            }
                            else
                            {
                                <option value="-1">--select--</option>
                                @foreach (var location in Locations)
                                {
                                    <option class="p-3" value="@location.Id">@location.Name</option>
                                }
                            }

                        </select>
                        <button class="btn btn-primary mt-2" @onclick="HandleChangeLocation">Save</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<DeleteConfirmation IsParentComponentProcessing="IsProcessing" ConfirmationChanged="ConfirmDelete_Click"></DeleteConfirmation>



@code {
    [Parameter]
    public int MatchCoreId { get; set; }

    public MatchFutsalDTO MatchFutsalModel { get; set; } = new MatchFutsalDTO();
    public MatchFutsalDTO MatchFutsalModelOnlyScore { get; set; } = new MatchFutsalDTO();
    public MatchCoreDTO MatchCoreModelOnlyMinutes { get; set; } = new MatchCoreDTO();
    public MatchCoreDTO MatchCoreModelOnlyLocation { get; set; } = new MatchCoreDTO();
    public MatchCoreDTO MatchCoreModelOnlyScore { get; set; } = new MatchCoreDTO();
    public IEnumerable<MatchCommentaryDTO> MatchCommentaryList { get; set; } = new List<MatchCommentaryDTO>();
    public IEnumerable<MatchFutsalDTO> list { get; set; } = new List<MatchFutsalDTO>();
    public MatchCoreDTO MatchCoreModel { get; set; } = new MatchCoreDTO();
    public IEnumerable<StadiumDTO> Locations { get; set; } = new List<StadiumDTO>();
    public IEnumerable<RefereeDTO> Referees { get; set; } = new List<RefereeDTO>();
    public RefereeMatchDTO RefereeMatchModel { get; set; } = new RefereeMatchDTO();
    private int? DeleteCommentId { get; set; } = null;
    private int SelectedRefereeId { get; set; }
    private int SelectedLocationId { get; set; }
    private bool IsProcessing { get; set; } = false;
    public int minutes { get; set; }
    public int seconds { get; set; }
    public bool isRunning { get; set; } = false;

    protected override async Task OnInitializedAsync()
    {
        MatchCoreModel = await MatchCoreRepository.Get(MatchCoreId);
        MatchFutsalModel = await MatchFutsalRepository.GetFromMatch(MatchCoreId);
        MatchCoreModelOnlyMinutes = MatchCoreModel;
        MatchCoreModelOnlyLocation = MatchCoreModel;
        MatchCommentaryList = await MatchCommentaryRepository.GetAllForMatch(MatchCoreId);


        Locations = await StadiumRepository.GetAll();
        Referees = await RefereeRepository.GetAll();
        RefereeMatchModel = await RefereeMatchRepository.GetFromMatch(MatchCoreId);
        minutes = MatchFutsalModel.Match.Minute;

    }
    private void HandleCreateUpdate() { }
    private async void Start()
    {
        if (MatchCoreModelOnlyMinutes.MatchStatus.Status.Equals("Scheduled"))
        {
            MatchCoreModelOnlyMinutes.MatchStatusId = 1;
            MatchCoreModelOnlyMinutes.Minute = 1;
            await MatchCoreRepository.Update(MatchCoreModelOnlyMinutes, MatchCoreModelOnlyMinutes.Id);
        }
        if (MatchCoreModelOnlyMinutes.MatchStatus.Status.Equals("Finished"))
        {
            isRunning = true; // block next "if" from happening - it won't count down time
            await JsRuntime.ToastrError("Match is already finished!");
        }
        if (isRunning == false)
        {
            isRunning = true;
            while (isRunning)
            {
                await Task.Delay(1000);
                if (isRunning == true)
                {
                    seconds++;
                    if (seconds == 60)
                    {
                        seconds = 0;
                        minutes++;
                        MatchCoreModelOnlyMinutes.Minute = minutes;
                        var result = await MatchCoreRepository.Update(MatchCoreModelOnlyMinutes, MatchCoreModelOnlyMinutes.Id);
                    }
                }
                StateHasChanged();
            }
        }
    }
    private void Stop()
    {
        isRunning = false;
    }
    private void Reset()
    {
        isRunning = false;
        seconds = 0;
        minutes = 0;
    }
    private async void Finished()
    {
        isRunning = false;
        seconds = 0;
        minutes = 40;
        MatchCoreModelOnlyMinutes.Minute = minutes;
        MatchCoreModelOnlyMinutes.MatchStatusId = 3;
        var result = await MatchCoreRepository.Update(MatchCoreModelOnlyMinutes, MatchCoreModelOnlyMinutes.Id);
        await JsRuntime.ToastrSuccess("Match finished successfully!");
    }
    private void PlusHomeTeam()
    {
        MatchCoreModel.TeamHomeScore++;
    }
    private void PlusAwayTeam()
    {
        MatchCoreModel.TeamAwayScore++;
    }
    private void MinusHomeTeam()
    {
        if (MatchCoreModel.TeamHomeScore > 0)
        {
            MatchCoreModel.TeamHomeScore--;
        }
    }
    private void MinusAwayTeam()
    {
        if (MatchCoreModel.TeamAwayScore > 0)
        {
            MatchCoreModel.TeamAwayScore--;
        }
    }

    async void HandleAddComment(int matchId, int minute)
    {
        var parameters = new ModalDialogParameters();
        parameters.Add("MatchId", matchId);
        parameters.Add("Minute", minute);
        var result = await ModalDialog.ShowDialogAsync<CommentDialog>("Add comment", new ModalDialogOptions(), parameters);
        MatchCommentaryList = await MatchCommentaryRepository.GetAllForMatch(MatchCoreId);
        StateHasChanged();
    }

    async void HandleCommentEdit(int commentId, int matchId, int minute)
    {
        var parameters = new ModalDialogParameters();
        parameters.Add("CommentId", commentId);
        parameters.Add("MatchId", matchId);
        parameters.Add("Minute", minute);
        //Modal.Show<DialogAddPlayer>("Add players", parameters);
        var result = await ModalDialog.ShowDialogAsync<CommentDialog>("Edit comment", new ModalDialogOptions(), parameters);
        MatchCommentaryList = await MatchCommentaryRepository.GetAllForMatch(MatchCoreId);
        StateHasChanged();
    }

    private async Task HandleDeleteComment(int commentId)
    {
        DeleteCommentId = commentId;
        await JsRuntime.InvokeVoidAsync("ShowDeleteConfirmationModal");
    }
    public async Task ConfirmDelete_Click(bool isConfirmed)
    {
        IsProcessing = true;
        if (isConfirmed && DeleteCommentId != null)
        {
            await MatchCommentaryRepository.Delete(DeleteCommentId.Value);
            await JsRuntime.ToastrSuccess("Comment deleted successfully!");
            MatchCommentaryList = await MatchCommentaryRepository.GetAllForMatch(MatchCoreId);
        }
        await JsRuntime.InvokeVoidAsync("HideDeleteConfirmationModal");
        IsProcessing = false;
    }

    private async Task HandleChangeReferee()
    {
        if(RefereeMatchModel == null)
        {
            RefereeMatchModel = new RefereeMatchDTO();
            RefereeMatchModel.RefereeId = SelectedRefereeId;
            RefereeMatchModel.MatchCoreId = MatchCoreId;
            var result = await RefereeMatchRepository.Create(RefereeMatchModel);
            await JsRuntime.ToastrSuccess("Referee added successfully");
        }
        else if(RefereeMatchModel.Referee.Id != SelectedRefereeId && SelectedRefereeId > 0)
        {
            RefereeMatchModel.RefereeId = SelectedRefereeId;
            await RefereeMatchRepository.Update(RefereeMatchModel, RefereeMatchModel.Id);
            await JsRuntime.ToastrSuccess("Referee updated successfully");
        }
        if(RefereeMatchModel != null && SelectedRefereeId == -1 )// if referee is already in database for that match, picking "---select---" will remove it
        {
            await RefereeMatchRepository.Delete(RefereeMatchModel.Id);
            await JsRuntime.ToastrSuccess("Referee removed successfully");
            StateHasChanged();
        }
    }
    private async Task HandleChangeLocation()
    {
        MatchCoreModelOnlyLocation.StadiumId = SelectedLocationId;
        var result = await MatchCoreRepository.Update(MatchCoreModelOnlyLocation, MatchCoreModelOnlyLocation.Id);
        await JsRuntime.ToastrSuccess("Location updated successfully");
    }
    private async Task HandleChangeScore()
    {
        var result = await MatchCoreRepository.Update(MatchCoreModel, MatchCoreModel.Id);
        await JsRuntime.ToastrSuccess("Score updated successfully");
    }
}
